function [w,b] = L2MSVM(xtrain,ytrain,lambda) 
%Input:
%   xtrain : n-by-d data matrix to train
%   ytrain : column vector of target {1, 2,...,k}'s
%   lambda : tuning parameter in scad function
% Output:
%   w : direction vector of separating hyperplane
%   b : the bias

global Result Prob

K = max(ytrain); %the number of classes
n = size(xtrain,1);
d = size(xtrain,2); 

A = ones(n,1)*(1:K);
ytrain2 = ytrain*ones(1,K);
A = (A~=ytrain2);
A = A(:);

Ab = [ones(n,1) zeros(n,K-1)];  
for i = 1:(K-1)
    Ab = [Ab;zeros(n,i) ones(n,1) zeros(n,K-1-i)];
end
Aw1 = [xtrain zeros(n,d*(K-1))];
for i = 1:(K-1)
    Aw1 = [Aw1;zeros(n,i*d) xtrain zeros(n,d*(K-1-i))];
end
Axi = diag(-ones(1,n*K));
Aineq = [Ab Aw1 Axi];
bineq = -ones(n*K,1);    

Aineq = [Aineq;zeros(n*K,K*(d+1)) -eye(n*K)];
bineq = [bineq;zeros(n*K,1)];
bineq2 = -Inf*ones(2*K*n,1);

aew = eye(d);
for i = 1:(K-1)
    aew = [aew eye(d)];
end    
Aeq = [zeros(d,K) aew zeros(d,n*K)];    
Aeq = [ones(1,K)  zeros(1,K*d+n*K);Aeq];
beq = zeros(1+d,1);

H = 2*lambda*diag([zeros(K,1);ones(K*d,1);zeros(n*K,1)]);
f = [zeros(K*(d+1),1);A]/n;

Aeq = [Aeq;Aineq];
bU = [beq;bineq];
bL = [beq;bineq2];
  
Prob = qpAssign(sparse(H),f,Aeq,bL,bU,[],[],[],'NL');
Prob = ProbCheck(Prob, 'sqopt');

Result = sqoptTL(Prob);
bwx=Result.x_k;

b = bwx(1:K);
w = bwx(K+1:K+K*d);
w = reshape(w,d,K);
w = w';
xi = bwx(K+K*d+1:K+K*d+n*K);
xi = reshape(xi,n,K);






   