function p = MCP (a,lambda,eta)
%MCP returns the value of the MCP penalty function
%Input:
%   a : tuning parameter in MCP function 
%   lambda : tuning parameter in MCP function
%   eta: the input parameter in MCP penalty
% Output:
%   p : the value of the MCP penalty

aeta = abs(eta);
p = (lambda.*aeta-0.5*aeta.^2/a).*(aeta<=a*lambda)+0.5*a*(lambda^2).*(aeta>a*lambda);
