function dp = MCPdev (a,lambda,eta)
%MCPdev returns the first derivative of the MCP penalty function
%Input:
%   a : tuning parameter in MCP function
%   lambda : tuning parameter in MCP function
%   eta: the input parameter in SCAD penalty
% Output:
%   dp : the differential of the MCP penalty

aeta = abs(eta);
dp = (lambda-aeta/a).*(aeta<=a*lambda);