function [w,b,xind,ind] = MPSVMsupSCADLLA(xtrain,ytrain,lambda) 
% Use LLA algorithm to implement SCAD MPSVM classification 
% Input:
%   xtrain : n-by-d data matrix to train
%   ytrain : column vector of target {1, 2,...,k}'s
%   lambda : tuning parameter in scad function
% Output:
%   w : direction vector of separating hyperplane
%   b : the bias
%   Ind : Indices of remained variables


a=3.7;  %tuning parameter in scad function
global Result Prob
K = max(ytrain); %the number of classes
n = size(xtrain,1);
d = size(xtrain,2); 


w = zeros(d,K);
b = zeros(K,1);
eta = max(abs(w),[],2); 
bw = [b';w];
oldbw = bw(:);
bwe0 = [oldbw;eta(:)];


bindex = 1:(d+1):1+(K-1)*(d+1);
windex = 2:(d+1);
for i = 1:(K-1)
    wi = (2+(d+1)*i):((d+1)+(d+1)*i);
    windex = [windex wi];
end 


diff = 1000;
flag = 0;
xind = 1:d;
ind = zeros(d,1);

A = ones(n,1)*(1:K);
ytrain2 = ytrain*ones(1,K);
A = (A~=ytrain2);

AA = repmat(A(:,1),1,(d+1));
AA = [AA zeros(n,(d+1)*(K-1))];
for k = 1:(K-1)
  AAA = [zeros(n,(d+1)*k) repmat(A(:,(k+1)),1,(d+1)) zeros(n,(d+1)*(K-k-1))];
  AA = [AA;AAA];
end 

  X = [ones(n,1) xtrain];
  XX = repmat(X,K,K);
  Q = XX.*AA;
  H = [Q'*Q.*(2/n) zeros(K*(d+1),d);zeros(d,K*(d+1)) zeros(d,d)];
  obj = oldbw'*(Q')*Q*oldbw./n+ones(1,n*K)*Q*oldbw.*(2/n)+sum(scadp(a,lambda,eta));
  
  % % b_1+b_2+...+b_K=0; w_1j+w_2j+...+w_Kj=0, for j=1,...d
  aeq = eye(d+1);
  for k = 1:(K-1)
    aeq = [aeq eye(d+1)];
  end    
  Aeq = [aeq zeros((d+1),d)];
  beq = zeros(d+1,1);
  
  a1 = [zeros(d,1) eye(d)];
  a2 = [a1(1,:);zeros((K-1),(d+1))];
  for k = 1:(K-1)
       a3 = [zeros(k,(d+1));a1(1,:);zeros((K-k-1),(d+1))];
       a2 = [a2 a3];
  end    
  for i = 2:d
     a4 = [a1(i,:);zeros((K-1),(d+1))];
     for k = 1:(K-1)
       a3 = [zeros(k,(d+1));a1(i,:);zeros((K-k-1),(d+1))];
       a4 = [a4 a3];
     end  
     a2 = [a2;a4];
  end    
  a5 = [-ones(K,1) zeros(K,(d-1))];
  for i = 1:(d-1)
      a6 = [zeros(K,i) -ones(K,1) zeros(K,d-1-i)];
      a5 = [a5;a6];
  end    
  % w_kj-eta_j<=0; -w_kj-eta_j<=0;
  Aineq = [a2 a5;-a2 a5];
  bineq = zeros(2*K*d,1);

  bineqL = -inf*ones(2*K*d,1);
  
  Aineq = [Aineq;Aeq];
  bineqL = [bineqL;beq];
  bineqU = [bineq;beq];
  
  dp = scaddp(a,lambda,eta);
  f = ones(1,n*K)*Q.*(2/n);
  f = f';  
  f = [f;dp];
  
lb = zeros(d,1);%eta_j>=0
lb = [-inf*ones(K+K*d,1);lb];

Prob = qpAssign(sparse(H),f,Aineq,bineqL,bineqU,lb,[],bwe0,'NL');
Prob = ProbCheck(Prob, 'sqopt');

  while (diff>(1e-6) && flag<100) 
    if ~isempty(Result)
        if length(Result.x_k) == Prob.N;
            Prob = WarmDefSOL('sqopt',Prob,Result);
        end
    end
    Result = sqoptTL(Prob);
    bwe=Result.x_k;
    nbw = bwe(1:(d+1)*K);
    nb = bwe(bindex);
    nw = bwe(windex);
    neta = bwe(((d+1)*K+1):end);
    diff = norm(nbw-oldbw);
    obj1 = nbw'*(Q')*Q*nbw./n+ones(1,n*K)*Q*nbw.*(2/n)+sum(scadp(a,lambda,neta));
    if (abs(obj1-obj)<(1e-8))
        flag = flag+1;
    end   
      ind = neta>1e-4;
      xind = 1:d;
     if(sum(ind)>0)
        xind = xind(ind);
        b = nb;
        w = nw;
        obj = obj1;
        eta = neta;
        oldbw = nbw;
       else
         diff=(1e-6)/2;
         xind = 0;
         ind = zeros(d,1);
         eta=zeros(d,1);
         w = zeros(d*K,1);
         b = zeros(K,1);
     end; 
     dp = scaddp(a,lambda,eta);
     f = ones(1,n*K)*Q.*(2/n);
     f = f';  
     f = [f;dp]; 
     Prob.QP.c = f;
  end 
  w = reshape(w,d,K);
  w = w';
 if (flag>99)
        lambda
        flag
 end