
function [w,b,xind,ind] = MSVMcompMCPLLA(xtrain,ytrain,lambda) 

%Use LLA algorithm to implement composite MCP MSVM classification
%Input:
%   xtrain : n-by-d data matrix to train
%   ytrain : column vector of target {1, 2,...,k}'s
%   lambda : tuning parameter in scad function 
%   
% Output:
%   w : direction vector of separating hyperplane
%   b : the bias
%   Ind : Indices of remained variables

flag = 0;
iter = 0;
global Result Prob

n = size(xtrain,1);
K = max(ytrain); %the number of classes


a = 3;
bb = 0.5*a*K*lambda;



d = size(xtrain,2); 
w = zeros(d*K,1);
b = zeros(K,1);
xi = ones(n*K,1);
eta = abs(w);
bwxe0 = [b;w;xi;eta];


diff = 1000;
xind = 1:d;
ind = zeros(d,1);
A = ones(n,1)*(1:K);
ytrain2 = ytrain*ones(1,K);
A = (A~=ytrain2);
A = A(:);

 sz = [d K];
 p = MCP(a,lambda,eta);
 pm = reshape(p,sz);
 pm2 = sum(pm,2);
 pm3 = MCP(bb,lambda,pm2);
 obj = (A'*xi)/n+sum(pm3);

Ab = [ones(n,1) zeros(n,K-1)];  
for i = 1:(K-1)
    Ab = [Ab;zeros(n,i) ones(n,1) zeros(n,K-1-i)];
end

Aw1 = [xtrain zeros(n,d*(K-1))];
for i = 1:(K-1)
    Aw1 = [Aw1;zeros(n,i*d) xtrain zeros(n,d*(K-1-i))];
end
Axi = diag(-ones(1,n*K));
Aineq = [Ab Aw1 Axi zeros(n*K,d*K)];% b_k0+w_k*x_i-xi_ik<=-1


aw = diag(-ones(1,d*K));
aw = [diag(ones(1,d*K));aw];

aeta = diag(-ones(1,d*K));
aeta = [aeta;aeta];
% beta_kj-eta_kj <= 0; -beta_kj-eta_kj <= 0
aww = [zeros(2*K*d,K) aw zeros(2*K*d,n*K) aeta];
Aineq = [Aineq;aww];
bineq = [-ones(n*K,1);zeros(2*K*d,1)];    

aew = eye(d);
for i = 1:(K-1)
    aew = [aew eye(d)];
end    
Aeq = [zeros(d,K) aew zeros(d,n*K+d*K)];    
Aeq = [ones(1,K) zeros(1,K*d+n*K+d*K);Aeq];%sum_{k=1}^{k=K}beta_kj=0;beta_10+...+beta_K0=0
beq = zeros(1+d,1);
lb = zeros(n*K+d*K,1);%xi_ik>=0;eta_j>=0
lb = [-inf*ones(K+K*d,1);lb];

 p = MCP(a,lambda,eta);
 dp = MCPdev(a,lambda,eta);
 pm = reshape(p,sz);
 pm2 = sum(pm,2);
 dpm2 = MCPdev(bb,lambda,pm2);
 dpm3 = repmat(dpm2,K,1);
 dp2 = dpm3.*dp;      

f = [zeros(K,1);zeros(K*d,1);A/n;dp2];
Prob = lpAssign(f,[Aineq;Aeq],[-inf*ones(K*(n+2*d),1);beq],[bineq;beq],lb,[],bwxe0,'NL');
Prob = ProbCheck(Prob,'cplex');

while (diff>1e-6 && flag<100)
    iter = iter + 1;
    Result = cplexTL(Prob);
    bwxe=Result.x_k;
    
    b = bwxe(1:K);
    nw = bwxe(K+1:K+K*d);
    xi = bwxe(K+K*d+1:K+K*d+n*K);
    eta = bwxe(K+K*d+n*K+1:end);
    diff = norm(bwxe-bwxe0);
    
    p = MCP(a,lambda,eta);
    pm = reshape(p,sz);
    pm2 = sum(pm,2);
    pm3 = MCP(bb,lambda,pm2);

    obj1 = (A'*xi)/n+sum(pm3);
    
    if (abs(obj1-obj)<1e-6)
        flag = flag+1;
    end 
    obj = obj1;
    bwxe0 = bwxe;
    
    eta2 = reshape(eta,sz);
    eta3 = max(eta2,[],2);
    ind = eta3>1e-4;  
    xind = 1:d;
    if(sum(ind)>0)
        xind = xind(ind);
    else
        xind = 0;
    end; 
 
 p = MCP(a,lambda,eta);
 dp = MCPdev(a,lambda,eta);
 pm = reshape(p,sz);
 pm2 = sum(pm,2);
 dpm2 = MCPdev(bb,lambda,pm2);
 dpm3 = repmat(dpm2,K,1);
 dp2 = dpm3.*dp;      

f = [zeros(K,1);zeros(K*d,1);A/n;dp2];
Prob = lpAssign(f,[Aineq;Aeq],[-inf*ones(K*(n+2*d),1);beq],[bineq;beq],lb,[],bwxe0,'NL');
Prob = ProbCheck(Prob,'cplex');  
end;
    w1 = reshape(nw,d,K);
    w = w1';
   
    