function d2 = dca2 (a,lambda,eta)
%dca2 returns the differential of the 2nd convex function in DCA algorithm
%Input:
%   a : tuning parameter in scad function (default: 3.7 or whatever the paper uses)
%   lambda : tuning parameter in scad function (default : 2 or whatever the paper uses)
%   eta: the input parameter in SCAD penalty
% Output:
%   d2 : the differential of the 2nd convex function in DCA algorithm

aeta = abs(eta);
d2 = lambda*(aeta>lambda)-(aeta>lambda&aeta<=a*lambda).*(a*lambda-aeta)/(a-1);
