function [g,H] = dev(xtrain2,ytrain2,P,d,K,n)
% PURPOSE: Computes gradient and Hessian of the negative log-likelihood of
% the symmetric multinomial logit model

tmp = P - ytrain2;
g = xtrain2'*tmp;

H = zeros(K*(d+1));
for m = 1:K 
    for l = 1:K
        fr = (m-1)*(d+1) + 1;
        lr = m*(d+1);
        fc = (l-1)*(d+1) + 1;
        lc = l*(d+1);       
        index = (l==m);
        index = repmat(index,n,1);
        H(fr:lr,fc:lc) = ((xtrain2.*(P(:,m)*ones(1,(d+1))))'*(xtrain2.*((index-P(:,l))*ones(1,(d+1)))));
    end;
end;
