
function [g,H] = multilogit_deriv(xtrain2,ytrain2,P,d,K,n);
% PURPOSE: Computes gradient and Hessian of multinomial logit 
% model
% ---------------------------------------------------------
% References: Greene (1997), p.914


% compute gradient matrix (nvar x ncat)
tmp = ytrain2 - P;
g = xtrain2'*tmp;

% compute Hessian, which has (ncat)^2 blocks of size (nvar x nvar)
% this algorithm builds each block individually, m&n are block indices

for m = 1:(K-1) 
    for l = 1:(K-1)
        fr = (m-1)*(d+1) + 1;
        lr = m*(d+1);
        fc = (l-1)*(d+1) + 1;
        lc = l*(d+1);       
        index = (l==m);
        index = repmat(index,n,1);
        H(fr:lr,fc:lc) = -((xtrain2.*(P(:,m)*ones(1,(d+1))))'*(xtrain2.*((index-P(:,l))*ones(1,(d+1)))));
    end;
end