function dp = scaddp (a,lambda,eta)
%scaddp returns the differential of the SCAD penalty function
%Input:
%   a : tuning parameter in scad function (default: 3.7 or whatever the paper uses)
%   lambda : tuning parameter in scad function (default : 2 or whatever the paper uses)
%   eta: the input parameter in SCAD penalty
% Output:
%   dp : the differential of the scad penalty

aeta = abs(eta);
dp = lambda*(aeta<=lambda)+(aeta>lambda&aeta<=a*lambda).*(a*lambda-aeta)/(a-1);