function p = scadp (a,lambda,eta)
%scaddp returns the value of the SCAD penalty function
%Input:
%   a : tuning parameter in scad function (default: 3.7 or whatever the paper uses)
%   lambda : tuning parameter in scad function (default : 2 or whatever the paper uses)
%   eta: the input parameter in SCAD penalty
% Output:
%   p : the value of the scad penalty

aeta = abs(eta);
p = lambda.*aeta.*(aeta<=lambda)-(aeta>lambda&aeta<=a*lambda).*(aeta.^2-2*a*lambda.*aeta+lambda^2)/(2*a-2)+0.5*(a+1)*(lambda^2).*(aeta>a*lambda);
