
addpath('C:/Users/nli/Documents/personal/supSCAD simulation/glmnet_matlab');

n=200;  %train data size
d=20;
K=4; 
nn=40000; %test data size
N=n+nn; 
r=100; %replicates

ytrain = ones(n/K,1);
for i = 1:(K-1)
    y = (i+1)*ones(n/K,1);
    ytrain = [ytrain;y];
end    

ytrain2 =( repmat(ytrain,1,K)==repmat(1:K,n,1));

ytest = ones(nn/K,1);
for i = 1:(K-1)
     y = (i+1)*ones(nn/K,1);
     ytest = [ytest;y];
end    

ytest2 =( repmat(ytest,1,K)==repmat(1:K,nn,1));

sigma = [3 0 0 0;0 3 0 0;0 0 1 0;0 0 0 1];

%tuning lambda
 lam = 2.^linspace(10,-10,21);
 
stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();

TE = zeros(r,1); %test error
P1 = zeros(r,1);
P2 = zeros(r,1);
CZ = zeros(r,1);
IZ = zeros(r,1);
MS = zeros(r,1);
CM = 0;
Mu = [sqrt(2) sqrt(2) 0.5 0.5;
    -sqrt(2) sqrt(2) -0.5 0.5;
    -sqrt(2) -sqrt(2) 0.5 -0.5;
    sqrt(2) -sqrt(2) -0.5 -0.5];
L = zeros(r,1);
EGKL = zeros(r,1);
NL = zeros(r,1);

for i = 1:r
 defaultStream.Substream = i;
 
 ptrue2 = zeros(nn,K);

 mu = [sqrt(2) sqrt(2) 0.5 0.5];
 x = mvnrnd(mu,sigma,N/K);
 xtrain = x(1:n/K,:);
 xtest = x(n/K+1:end,:);
 
 mu = [-sqrt(2) sqrt(2) -0.5 0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
  
 mu = [-sqrt(2) -sqrt(2) 0.5 -0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
 
 mu = [sqrt(2) -sqrt(2) -0.5 -0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];

for t = 1:nn
    for k = 1:K
    ptrue2(t,k) = mvnpdf(xtest(t,:),Mu(k,:),sigma);
    end
end
s2 = sum(ptrue2,2);
ptrue2 = ptrue2./repmat(s2,1,K);

xx = randn(N,16);

xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];
 
meanx=mean(xtrain);
scalex=std(xtrain);
xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);
  
options=glmnetSet();
options.standardize=false;
options.lambda=lam;

fit=glmnet(xtrain,ytrain,'multinomial',options);

ptrain_hat=log(glmnetPredict(fit,xtrain,[],'response'));
coef_hat=glmnetPredict(fit,[],[],'coefficients');

bic=zeros(21,1);
for j = 1:21
coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),j);
coefs(:,2)=coef_hat{2}(2:(d+1),j);
coefs(:,3)=coef_hat{3}(2:(d+1),j);
coefs(:,4)=coef_hat{4}(2:(d+1),j);
coefs=coefs';
nz=sum(sum(abs(coefs)>1e-4));

bic(j)=-2*sum(sum(ytrain2.*ptrain_hat(:,:,j)))/n+log(n)*nz/n;
end
[me,select]=min(bic);
lam_select=lam(select);
L(i)=lam_select;


ytest_hat=glmnetPredict(fit,xtest,lam_select,'class');
err = sum(ytest_hat~=ytest)/nn;

prob_test=glmnetPredict(fit,xtest,lam_select,'response');
P1(i)=sum(sum(abs(ptrue2-prob_test)))/nn;
P2(i)=sum(sum((ptrue2-prob_test).^2))/nn;
EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(prob_test))))/nn;
NL(i)=-sum(sum(ytest2.*log(prob_test)))/nn;
  
TE(i) = err;

%coef=glmnetPredict(fit,xtest,lam_select,'coefficients');
%coefs=zeros(d,K);
%coefs(:,1)=coef{1}(2:(d+1));
%coefs(:,2)=coef{2}(2:(d+1));
%coefs(:,3)=coef{3}(2:(d+1));
%coefs(:,4)=coef{4}(2:(d+1));
%coefs=coefs';

coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),select);
coefs(:,2)=coef_hat{2}(2:(d+1),select);
coefs(:,3)=coef_hat{3}(2:(d+1),select);
coefs(:,4)=coef_hat{4}(2:(d+1),select);
coefs=coefs';


CZ(i) = sum(sum(abs(coefs(:,5:20))<1e-4));
IZ(i) = sum(sum(abs(coefs(:,1:4))<1e-4));

MS(i) = sum(max(abs(coefs))>1e-4);

if(MS(i)==4 & CZ(i)==64 & max(abs(coefs(:,1)))>1e-4 & max(abs(coefs(:,2)))>1e-4 & max(abs(coefs(:,3)))>1e-4 & max(abs(coefs(:,4)))>1e-4)  
  CM = CM+1;
end


i
err
lam_select
coefs
end

mean(TE)
mean(P1)
mean(P2)
mean(CZ)
mean(IZ)
mean(MS)
CM
mean(EGKL)

