

clear all;clc;
addpath('C:\tomlab');
addpath('C:\Users\Jean Wu\Desktop\supSCAD simulation\LR_examples\supSCAD_MCP');
startup;


n=200;  %train data size
d=20;
K=4; 
nn=40000; %test data size
N=n+nn; 
r=100; %replicates

%intianl point zero
B=zeros(d+1,K);


ytrain = ones(n/K,1);
for i = 1:(K-1)
    y = (i+1)*ones(n/K,1);
    ytrain = [ytrain;y];
end    

ytrain2 =( repmat(ytrain,1,K)==repmat(1:K,n,1));

ytest = ones(nn/K,1);
for i = 1:(K-1)
     y = (i+1)*ones(nn/K,1);
     ytest = [ytest;y];
end    

ytest2 =( repmat(ytest,1,K)==repmat(1:K,nn,1));

sigma = [3 0 0 0;0 3 0 0;0 0 1 0;0 0 0 1];

%tuning lambda
 Lambda = 2.^linspace(10,-10,21);
 
stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();

TE = zeros(r,1); %test error
P1 = zeros(r,1);
P2 = zeros(r,1);
CZ = zeros(r,1);
IZ = zeros(r,1);
MS = zeros(r,1);
CM = 0;
Mu = [sqrt(2) sqrt(2) 0.5 0.5;
    -sqrt(2) sqrt(2) -0.5 0.5;
    -sqrt(2) -sqrt(2) 0.5 -0.5;
    sqrt(2) -sqrt(2) -0.5 -0.5];
L = zeros(r,1);
EGKL = zeros(r,1);


for i = 1:r
 defaultStream.Substream = i;
 
 ptrue2 = zeros(nn,K);

 mu = [sqrt(2) sqrt(2) 0.5 0.5];
 x = mvnrnd(mu,sigma,N/K);
 xtrain = x(1:n/K,:);
 xtest = x(n/K+1:end,:);
 
 mu = [-sqrt(2) sqrt(2) -0.5 0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
  
 mu = [-sqrt(2) -sqrt(2) 0.5 -0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
 
 mu = [sqrt(2) -sqrt(2) -0.5 -0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];

for t = 1:nn
    for k = 1:K
    ptrue2(t,k) = mvnpdf(xtest(t,:),Mu(k,:),sigma);
    end
end
s2 = sum(ptrue2,2);
ptrue2 = ptrue2./repmat(s2,1,K);

xx = randn(N,16);

xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];
 
meanx=mean(xtrain);
scalex=std(xtrain);
xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);
  
bic=zeros(length(Lambda),3);

for l = 1:length(Lambda)
    
     [w,b,xind] = LRsupSCADLLA(xtrain,ytrain,Lambda(l),B);
     ftrain = xtrain*w'+ones(n,1)*b';
     ftrain = exp(ftrain);
     ftrain2 = sum(ftrain,2);
     ptrain = log(ftrain./repmat(ftrain2,1,K));
     nz = sum(sum(abs(w)>1e-4));
    
     bic(l,1) =  Lambda(l);
     bic(l,2) = -2*sum(sum(ytrain2.*ptrain))/n+log(n)*nz/n;
     bic(l,3) = length(xind);
     
end

  [mn,index] = min(bic(:,2));
  lambda = bic(index,1);
  L(i) = lambda;




[w,b,xind,ind] = LRsupSCADLLA(xtrain,ytrain,lambda,B);
     ftest = xtest*w'+ones(nn,1)*b';
     ftest = exp(ftest);
     ftest2 = sum(ftest,2);
     ftest = ftest./repmat(ftest2,1,K);
     [fftest,index] = max(ftest,[],2);
     err = sum(ytest~=index)/nn;
     
  P1(i) = sum(sum(abs(ftest-ptrue2)))/nn;
  P2(i) = sum(sum((ftest-ptrue2).^2))/nn;
  TE(i) = err;
 
  EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(ftest))))/nn;


CZ(i) = sum(sum(abs(w(:,5:20))<1e-4));
IZ(i) = sum(sum(abs(w(:,1:4))<1e-4));

MS(i) = sum(max(abs(w))>1e-4);


if(MS(i)==4 & max(abs(w(:,1)))>1e-4 & max(abs(w(:,2)))>1e-4 & max(abs(w(:,3)))>1e-4 & max(abs(w(:,4)))>1e-4)  
  CM = CM+1;
end

i
err
lambda
w
end

mean(TE)

mean(P1)

mean(P2)

mean(CZ)

mean(IZ)

mean(MS)

CM

mean(EGKL)

