

clear all;clc;
addpath('C:\tomlab');
addpath('C:\Users\Jean Wu\Desktop\supSCAD simulation\SVM_examples');
startup;


n=200;  %train and tune data size
d=20;  %input vector dimension
K=4;    %4-class
nn=40000; %test data size
N=n+nn; 
r=100; %replicates


ytrain = ones(n/K,1);
for i = 1:(K-1)
    y = (i+1)*ones(n/K,1);
    ytrain = [ytrain;y];
end    


ytest = ones(nn/K,1);
for i = 1:(K-1)
     y = (i+1)*ones(nn/K,1);
     ytest = [ytest;y];
end    

sigma = [3 0 0 0;0 3 0 0;0 0 1 0;0 0 0 1];

%tuning lambda
 Lambda = 2.^linspace(10,-10,21);
   
stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();

TE = zeros(r,1); %test error
CZ = zeros(r,1); %correct zeros
IZ = zeros(r,1); %incorrect zeros
MS = zeros(r,1); %model size
CM = 0; %correct model
SF = zeros(r,d); %selection frequency
L = zeros(r,1);
P1 = zeros(r,1);
P2 = zeros(r,1);
Mu = [sqrt(2) sqrt(2) 0.5 0.5;
    -sqrt(2) sqrt(2) -0.5 0.5;
    -sqrt(2) -sqrt(2) 0.5 -0.5;
    sqrt(2) -sqrt(2) -0.5 -0.5];

EGKL = zeros(r,1);

for i = 1:r
    
 defaultStream.Substream = i;
  %simulation setup
 mu = [sqrt(2) sqrt(2) 0.5 0.5];
 X = mvnrnd(mu,sigma,N/K);
 xtrain = X(1:(n/K),:);
 xtest = X(n/K+1:end,:);
 
 mu = [-sqrt(2) sqrt(2) -0.5 0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
  
 mu = [-sqrt(2) -sqrt(2) 0.5 -0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
 
 mu = [sqrt(2) -sqrt(2) -0.5 -0.5];
 x = mvnrnd(mu,sigma,N/K); 
 xtrain = [xtrain;x(1:n/K,:)];
 xtest = [xtest;x((n/K+1:end),:)];
 


for t = 1:nn
    for k = 1:K
    ptrue2(t,k) = mvnpdf(xtest(t,:),Mu(k,:),sigma);
    end
end
s2 = sum(ptrue2,2);
ptrue2 = ptrue2./repmat(s2,1,K);

 xx = randn(N,16);

xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];

meanx=mean(xtrain);
scalex=std(xtrain);
xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);

 %five-fold cross-validation
splitsize = floor(n/5) * ones(5, 1);
splitsize(5) = n - (5 - 1) * floor(n/5);
pn = randperm(n);

 Tunerr = zeros(length(Lambda),2);
  for l = 1:length(Lambda)
       cv = zeros(1,5);
     for run = 1:5
      tuneindex = pn(((run - 1) * floor(n/5) + 1) : ((run - 1) * floor(n/5) + splitsize(run)));
      temp = zeros(n, 1);
      temp(tuneindex) = 1;
      cvytune = ytrain(logical(temp));
      cvytrain = ytrain(logical(1-temp));

      cvntrain = length(cvytrain);
      cvntune = length(cvytune);
      cvxtrain = xtrain(logical(1-temp),:);
      cvxtune = xtrain(logical(temp),:);
     [w,b] = MPSVMsupSCADLLA(cvxtrain,cvytrain,Lambda(l));
      ftune = cvxtune*w'+ones(cvntune,1)*b';
     [fftune,index] = max(ftune,[],2);
     cv(run) = sum(cvytune~=index)/cvntune;
     end
     Tunerr(l,1) =  Lambda(l);
     Tunerr(l,2) = mean(cv);
  end
  

    [mn,index] = min(Tunerr(:,2));
    lambda = Tunerr(index,1);
    L(i) = lambda;

%solve SCADSVM using DCA
 [w,b,xind,ind] = MPSVMsupSCADLLA(xtrain,ytrain,lambda);
 ftest = xtest*w'+ones(nn,1)*b';
 [fftest,index] = max(ftest,[],2);
 ftest = 1./(1+ftest);
  ffsum = sum(ftest,2);
  ptest = ftest./repmat(ffsum,1,K);
  ptest = 1-(K-1).*ptest; 
  
  
%scale P
pmin = min(ptest,[],2);
ptest = ptest - repmat(pmin,1,K);
ptest = ptest./repmat(sum(ptest,2),1,K);
  
  P1(i) = sum(sum(abs(ptest-ptrue2)))/nn;
  P2(i) = sum(sum((ptest-ptrue2).^2))/nn;
    EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(ptest))))/nn;
    
  err = sum(ytest~=index)/nn;
  TE(i) = err;
  SF(i,:) = ind';
  MS(i) = sum(ind);
  w1 = abs(w(:,1:4))<1e-4;
  w2 = abs(w(:,5:end))<1e-4;
  IZ(i) = sum(sum(w1));
  CZ(i) = sum(sum(w2));  
  if (MS(i)==4 & xind==[1 2 3 4])
      CM=CM+1;
  end    
  i
  lambda
  err
  xind
  w
end

mean(TE)
mean(CZ)
mean(IZ)
mean(MS)
 CM
sum(SF)
mean(P1)
mean(P2)
mean(EGKL)
