
clear all;clc;
addpath('C:/tomlab');
addpath('C:\Users\Jean Wu\Dropbox\submission\supSCAD simulation\SVM_examples');
startup;

n=200;
d=20;
K=4;
nn=40000;
N=n+nn;
r=100;
class = (1:K)';

%simulation setup
 TE = zeros(r,1); %test error

 MS = zeros(r,1); %model size
 
 L = zeros(r,1);

 
 Lambda = 2.^linspace(10,-10,21);


stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();


for i = 1:r
    
defaultStream.Substream = i;

tempx=randn(N,4);
tempr=rand([N,1]);
tempr=tempr.^(1/4);
tempz=repmat(tempr,1,4).*tempx;
tempx2=zeros(N,1);
for j=1:N
tempx2(j)=norm(tempx(j,:));
end
x1=3*tempz./repmat(tempx2,1,4);
x2 = randn(N,16);
x = [x1 x2];

xtrain = x(1:n,:);
xtest = x(n+1:end,:);
 
meanx=mean(xtrain);
scalex=std(xtrain);
xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);


f1 = -3*x(:,1)+3*x(:,4);
f2 = 3*x(:,1)+3*x(:,2);
f3 = -3*x(:,2)+3*x(:,3);
f4 = -3*x(:,3)-3*x(:,4);
p = [f1 f2 f3 f4];
p = exp(p);
pp = sum(p,2);
pp = 1./pp;
pp = pp*ones(1,K);
p = p.*pp;
ptrue2 = p(n+1:end,:);
y1 = mnrnd(ones(N,1),p);
y = y1*class;

ytrain = y(1:n);
ytest = y(n+1:end);


 %five-fold cross-validation
splitsize = floor(n/5) * ones(5, 1);
splitsize(5) = n - (5 - 1) * floor(n/5);
pn = randperm(n);
 Tunerr = zeros(length(Lambda),2);
 
  for l = 1:length(Lambda)
       cv = zeros(1,5);
     for run = 1:5
      tuneindex = pn(((run - 1) * floor(n/5) + 1) : ((run - 1) * floor(n/5) + splitsize(run)));
      temp = zeros(n, 1);
      temp(tuneindex) = 1;
      cvytune = ytrain(logical(temp));
      cvytrain = ytrain(logical(1-temp));

      cvntrain = length(cvytrain);
      cvntune = length(cvytune);
      cvxtrain = xtrain(logical(1-temp),:);
      cvxtune = xtrain(logical(temp),:);
     [w,b] = L2MSVM(cvxtrain,cvytrain,Lambda(l));
      ftune = cvxtune*w'+ones(cvntune,1)*b';
     [fftune,index] = max(ftune,[],2);
     cv(run) = sum(cvytune~=index)/cvntune;
     end
     Tunerr(l,1) =  Lambda(l);
     Tunerr(l,2) = mean(cv);
  end

   [mn,index] = min(Tunerr(:,2));
   lambda = Tunerr(index,1);
   L(i) = lambda;

  [w,b] = L2MSVM(xtrain,ytrain,lambda);

  ftest = xtest*w'+ones(nn,1)*b';
  [fftest,index] = max(ftest,[],2);
   err = sum(ytest~=index)/nn;
   TE(i) = err;
   MS(i) = sum(max(abs(w))>1e-4);
    
 
   i
   lambda
   err

  
end

mean(TE)%0.34
std(TE)%0.0531


min(MS)%20
max(MS)%20




