
addpath('C:/Users/nli/Documents/personal/supSCAD simulation/glmnet_matlab');

n = 200;
d = 20;
K = 4;
nn = 40000;
N = n+nn;
r = 100;
class = (1:K)';

%simulation setup
 TE = zeros(r,1); %test error
 P1 = zeros(r,1);
 P2 = zeros(r,1);
 CZ = zeros(r,1);
 IZ = zeros(r,1);
 MS = zeros(r,1);
 CM = 0;
 L = zeros(r,1);
 EGKL = zeros(r,1);
 NL = zeros(r,1);

 %tuning lambda
  lam = 2.^linspace(10,-10,21);
 
stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();

for i = 1:r
defaultStream.Substream = i;

tempx=randn(N,4);
tempr=rand([N,1]);
tempr=tempr.^(1/4);
tempz=repmat(tempr,1,4).*tempx;
tempx2=zeros(N,1);
for j=1:N
tempx2(j)=norm(tempx(j,:));
end
x1=3*tempz./repmat(tempx2,1,4);
x2 = randn(N,16);
x = [x1 x2];

xtrain = x(1:n,:);
xtest = x(n+1:end,:);
 
meanx=mean(xtrain);
scalex=std(xtrain);
xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);



f1 = -3*x(:,1)+3*x(:,4);
f2 = 3*x(:,1)+3*x(:,2);
f3 = -3*x(:,2)+3*x(:,3);
f4 = -3*x(:,3)-3*x(:,4);
p = [f1 f2 f3 f4];
p = exp(p);
pp = sum(p,2);
pp = 1./pp;
pp = pp*ones(1,K);
p = p.*pp;
ptrue2 = p(n+1:end,:);
y1 = mnrnd(ones(N,1),p);
y = y1*class;

ytrain = y(1:n);
ytest = y(n+1:end);
 
ytrain2 = y1(1:n,:);
ytest2 = y1(n+1:end,:);

options=glmnetSet();
options.standardize=false;
options.lambda=lam;


fit=glmnet(xtrain,ytrain,'multinomial',options);

ptrain_hat=log(glmnetPredict(fit,xtrain,[],'response'));
coef_hat=glmnetPredict(fit,[],[],'coefficients');


bic=zeros(21,1);
for j = 1:21
coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),j);
coefs(:,2)=coef_hat{2}(2:(d+1),j);
coefs(:,3)=coef_hat{3}(2:(d+1),j);
coefs(:,4)=coef_hat{4}(2:(d+1),j);
coefs=coefs';
nz=sum(sum(abs(coefs)>1e-4));

bic(j)=-2*sum(sum(ytrain2.*ptrain_hat(:,:,j)))/n+log(n)*nz/n;
end
[me,select]=min(bic);
lam_select=lam(select);
L(i)=lam_select;

ytest_hat=glmnetPredict(fit,xtest,lam_select,'class');
err = sum(ytest_hat~=ytest)/nn;


prob_test=glmnetPredict(fit,xtest,lam_select,'response');
P1(i)=sum(sum(abs(ptrue2-prob_test)))/nn;
P2(i)=sum(sum((ptrue2-prob_test).^2))/nn;
EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(prob_test))))/nn;
NL(i)=-sum(sum(ytest2.*log(prob_test)))/nn;
TE(i) = err;

coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),select);
coefs(:,2)=coef_hat{2}(2:(d+1),select);
coefs(:,3)=coef_hat{3}(2:(d+1),select);
coefs(:,4)=coef_hat{4}(2:(d+1),select);
coefs=coefs';

 
MS(i) = sum(max(abs(coefs))>1e-4);
ind = sum(max(abs(coefs(:,5:d)))>1e-4);
if(MS(i)==4 & ind==0)  
    CM = CM+1;
end

id = [1;2;6;7;11;12;13;16];
id2 = [3;4;5;8;9;10;14;15;(17:80)'];
coefs2 = coefs(:);
CZ(i) = sum(abs(coefs2(id2))<1e-4);
IZ(i) = sum(abs(coefs2(id))<1e-4);

i
err
lam_select
coefs

end



mean(TE)

mean(P1)

mean(P2) 

mean(CZ) 
mean(IZ) 
mean(MS) 
CM 
mean(EGKL) 

