

clear all;clc;
addpath('C:/tomlab');
addpath('C:/Users/Jean Wu/Desktop/supSCAD simulation/LR_examples/supSCAD_MCP');
startup;


n = 200;
d = 20;
K = 4;
nn = 40000;
N = n+nn;
r = 100;
class = (1:K)';


%simulation setup
 TE = zeros(r,1); %test error
 P1 = zeros(r,1);
 P2 = zeros(r,1);
 CZ = zeros(r,1);
 IZ = zeros(r,1);
 MS = zeros(r,1);
 CM = 0;
 L = zeros(r,1);
 EGKL = zeros(r,1);
 
load('BB3dev.mat');


%tuning lambda
 Lambda = 2.^linspace(10,-7,18);
 
stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();



for i = 1:r
    
 defaultStream.Substream = i;
 
 tempx=randn(N,4);
tempr=rand([N,1]);
tempr=tempr.^(1/4);
tempz=repmat(tempr,1,4).*tempx;
tempx2=zeros(N,1);
for j=1:N
tempx2(j)=norm(tempx(j,:));
end
x1=3*tempz./repmat(tempx2,1,4);
x2 = randn(N,16);
x = [x1 x2];

xtrain = x(1:n,:);
xtest = x(n+1:end,:);
 
meanx = mean(xtrain);
scalex = std(xtrain);
xtrain = (xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest = (xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);


f1 = -3*x(:,1)+3*x(:,4);
f2 = 3*x(:,1)+3*x(:,2);
f3 = -3*x(:,2)+3*x(:,3);
f4 = -3*x(:,3)-3*x(:,4);
p = [f1 f2 f3 f4];
p = exp(p);
pp = sum(p,2);
pp = 1./pp;
pp = pp*ones(1,K);
p = p.*pp;
ptrue2 = p(n+1:end,:);
y1 = mnrnd(ones(N,1),p);
y = y1*class;

ytrain = y(1:n);
ytest = y(n+1:end);
 
ytrain2 = y1(1:n,:);
ytest2 = y1(n+1:end,:);


%%ridge estimator%%
  B = BB(:,:,i);
  
bic=zeros(length(Lambda),3);

for l = 1:length(Lambda)
    
     [w,b,xind] = LRcompositeMCPLLAr(xtrain,ytrain,Lambda(l),B);
     ftrain = xtrain*w+ones(n,1)*b';
     ftrain = exp(ftrain);
     ftrain2 = sum(ftrain,2);
     ptrain = log(ftrain./repmat(ftrain2,1,K));
     nz = sum(sum(abs(w)>1e-4));
    
     bic(l,1) =  Lambda(l);
     bic(l,2) = -2*sum(sum(ytrain2.*ptrain))/n+log(n)*nz/n;
     bic(l,3) = length(xind);
     
end

  [mn,index] = min(bic(:,2));
  lambda = bic(index,1);
  L(i) = lambda;
  
  

[w,b,xind,ind] = LRcompositeMCPLLAr(xtrain,ytrain,lambda,B);
     ftest = xtest*w+ones(nn,1)*b';
     ftest = exp(ftest);
     ftest2 = sum(ftest,2);
     ftest = ftest./repmat(ftest2,1,K);
     [fftest,index] = max(ftest,[],2);
     err = sum(ytest~=index)/nn;
     
  P1(i) = sum(sum(abs(ftest-ptrue2)))/nn;
  P2(i) = sum(sum((ftest-ptrue2).^2))/nn;
  TE(i) = err;
 
  EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(ftest))))/nn;

  
w2=w';
MS(i) = sum(max(abs(w2))>1e-4);


ind = sum(max(abs(w2(:,5:d)))>1e-4);
if(MS(i)==4 & ind==0)  
    CM = CM+1;
end


id = [1;2;6;7;11;12;13;16];
id2 = [3;4;5;8;9;10;14;15;(17:80)'];
coefs2 = w2(:);
CZ(i) = sum(abs(coefs2(id2))<1e-4);
IZ(i) = sum(abs(coefs2(id))<1e-4);

i
err
lambda
w

end

mean(TE)

mean(P1)

mean(P2)

mean(CZ)

mean(IZ)

mean(MS)

CM

mean(EGKL)

