% Example 5.2 in Zhang et al.(2008).
% Using SCAD-supnorm LLA


clear all;clc;
addpath('C:\tomlab');
addpath('C:\Users\Jean Wu\Desktop\supSCAD simulation\SVM_examples');
startup;

n=200;
d=20;
K=4;
nn=40000;
N=n+nn;
r=100;
class = (1:K)';

%simulation setup
 TE = zeros(r,1); %test error
 CZ = zeros(r,1); %correct zeros
 IZ = zeros(r,1); %incorrect zeros
 MS = zeros(r,1); %model size
 CM = 0; %correct model
 SF = zeros(r,d); %selection frequency
 L = zeros(r,1);
 P1 = zeros(r,1);
 P2 = zeros(r,1);
 EGKL = zeros(r,1);
 
  Lambda = zeros(30,1);
  for i = 1:30;
     Lambda(i)=2^(15-i);
  end;

stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();

for i = 1:r
defaultStream.Substream = i;


tempx=randn(N,4);
tempr=rand([N,1]);
tempr=tempr.^(1/4);
tempz=repmat(tempr,1,4).*tempx;
tempx2=zeros(N,1);
for j=1:N
tempx2(j)=norm(tempx(j,:));
end
x1=3*tempz./repmat(tempx2,1,4);
x2 = randn(N,16);
x = [x1 x2];

xtrain = x(1:n,:);
xtest = x(n+1:end,:);
 
meanx=mean(xtrain);
scalex=std(xtrain);
xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);



f1 = -3*x(:,1)+3*x(:,4);
f2 = 3*x(:,1)+3*x(:,2);
f3 = -3*x(:,2)+3*x(:,3);
f4 = -3*x(:,3)-3*x(:,4);
p = [f1 f2 f3 f4];
p = exp(p);
pp = sum(p,2);
pp = 1./pp;
pp = pp*ones(1,K);
p = p.*pp;
ptrue2 = p(n+1:end,:);
y = mnrnd(ones(N,1),p);
y = y*class;

ytrain = y(1:n);
ytest = y(n+1:end);


 %five-fold cross-validation
splitsize = floor(n/5) * ones(5, 1);
splitsize(5) = n - (5 - 1) * floor(n/5);
pn = randperm(n);

 Tunerr = zeros(length(Lambda),2);
  for l = 1:length(Lambda)
      
       cv = zeros(1,5);
     for run = 1:5
      tuneindex = pn(((run - 1) * floor(n/5) + 1) : ((run - 1) * floor(n/5) + splitsize(run)));
      temp = zeros(n, 1);
      temp(tuneindex) = 1;
      cvytune = ytrain(logical(temp));
      cvytrain = ytrain(logical(1-temp));

      cvntrain = length(cvytrain);
      cvntune = length(cvytune);
      cvxtrain = xtrain(logical(1-temp),:);
      cvxtune = xtrain(logical(temp),:);
     [w,b] = MPSVMsupSCADLLA(cvxtrain,cvytrain,Lambda(l));
      ftune = cvxtune*w'+ones(cvntune,1)*b';
     [fftune,index] = max(ftune,[],2);
     cv(run) = sum(cvytune~=index)/cvntune;
     end
     Tunerr(l,1) =  Lambda(l);
     Tunerr(l,2) = mean(cv);
  end

   [mn,index] = min(Tunerr(:,2));
   lambda = Tunerr(index,1);
   L(i) = lambda;

  [w,b,xind,ind] = MPSVMsupSCADLLA(xtrain,ytrain,lambda);
  ftest = xtest*w'+ones(nn,1)*b';
  [fftest,index] = max(ftest,[],2);
  ftest = 1./(1+ftest);
  ffsum = sum(ftest,2);
  ptest = ftest./repmat(ffsum,1,K);
  ptest = 1-(K-1).*ptest; 
  
  
%scale P
pmin = min(ptest,[],2);
ptest = ptest - repmat(pmin,1,K);
ptest = ptest./repmat(sum(ptest,2),1,K);
  
  P1(i) = sum(sum(abs(ptest-ptrue2)))/nn;
  P2(i) = sum(sum((ptest-ptrue2).^2))/nn;
  EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(ptest))))/nn;
    
   err = sum(ytest~=index)/nn;
   TE(i) = err;
   SF(i,:) = ind';
   MS(i) = sum(ind);
   if (MS(i)==4 & xind==[1 2 3 4])
       CM=CM+1;
   end   
  id = [1;2;6;7;11;12;13;16];
  cd = [3;4;5;8;9;10;14;15;(17:80)'];
  ww = w(:);
  w1 = abs(ww(id))<1e-4;
  w2 = abs(ww(cd))<1e-4;
  IZ(i) = sum(w1);
  CZ(i) = sum(w2);  
   i
   lambda
   err
   xind
   w
end


mean(TE)
mean(CZ)
mean(IZ)
mean(MS)
CM
sum(SF)
mean(P1)
mean(P2)
mean(EGKL)


