

clear all;clc;
addpath('C:/tomlab');
addpath('C:/Users/Jean Wu/Dropbox/submission/supSCAD simulation/SVM_examples');
startup;


n=200;  %train and tune data size
d=200;  %input vector dimension
K=3;    %3-class
nn=40000; %test data size
N=n+nn; 
r=100; %replicates



sigma = [0.3 0;
         0 0.3];

TE = zeros(r,1); %test error
CZ = zeros(r,1);
IZ = zeros(r,1);
MS = zeros(r,1);
CM = 0;
L = zeros(r,1);
Mu = [cos(pi/3) sin(pi/3);
       cos(pi) sin(pi);
       cos(5*pi/3) sin(5*pi/3)];


%tuning lambda
 Lambda = 2.^linspace(10,-10,21);

stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();


for i = 1:r
    
 defaultStream.Substream = i;
 
  %simulation setup
  
ytrain2 = mnrnd(1,[1/3 1/3 1/3],n);
ytrain = ytrain2*(1:K)';

ytest2 = mnrnd(1,[1/3 1/3 1/3],nn);
ytest = ytest2*(1:K)';

kk1=sum(ytrain2,1);

kk2 = sum(ytest2,1);
kk = kk1+kk2;



xtrain = NaN(n,2);
xtest = NaN(nn,2);

 mu = [cos(pi/3) sin(pi/3)];
 X1 = mvnrnd(mu,sigma,kk(1));
 
 
 xtrain((ytrain==1),:) = X1(1:kk1(1),:);
 xtest((ytest==1),:) = X1((kk1(1)+1):end,:);

 
 mu = [cos(pi) sin(pi)];
 X2 = mvnrnd(mu,sigma,kk(2)); 
 
 xtrain((ytrain==2),:) = X2(1:kk1(2),:);
 xtest((ytest==2),:) = X2((kk1(2)+1):end,:);
  
 mu = [cos(5*pi/3) sin(5*pi/3)];
 X3 = mvnrnd(mu,sigma,kk(3)); 
 
xtrain((ytrain==3),:) = X3(1:kk1(3),:);
xtest((ytest==3),:) = X3((kk1(3)+1):end,:);
 
 
 
xx = sqrt(0.5)*randn(N,d-2);
xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];

 meanx=mean(xtrain);
 scalex=std(xtrain);
 xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
 xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);

 
  %five-fold cross-validation
 splitsize = floor(n/5) * ones(5, 1);
 splitsize(5) = n - (5 - 1) * floor(n/5);
 pn = randperm(n);
 
 Tunerr=zeros(length(Lambda),2);
 
 for l = 1:length(Lambda)
      
       cv = zeros(1,5);
     for run = 1:5
      tuneindex = pn(((run - 1) * floor(n/5) + 1) : ((run - 1) * floor(n/5) + splitsize(run)));
      temp = zeros(n, 1);
      temp(tuneindex) = 1;
      cvytune = ytrain(logical(temp));
      cvytrain = ytrain(logical(1-temp));

      cvntrain = length(cvytrain);
      cvntune = length(cvytune);
      cvxtrain = xtrain(logical(1-temp),:);
      cvxtune = xtrain(logical(temp),:);
     [w,b] =AL1MSVM(cvxtrain,cvytrain,Lambda(l));
      ftune = cvxtune*w'+ones(cvntune,1)*b';
     [fftune,index] = max(ftune,[],2);
     cv(run) = sum(cvytune~=index)/cvntune;
     end
     Tunerr(l,1) =  Lambda(l);
     Tunerr(l,2) = mean(cv);
  end


  [mn,index] = min(Tunerr(:,2));
   lambda = Tunerr(index,1);
   L(i) = lambda;



 [w,b,ind,xind] = AL1MSVM(xtrain,ytrain,lambda);
 ftest = xtest*w'+ones(nn,1)*b';
 [fftest,index] = max(ftest,[],2);
  err = sum(ytest~=index)/nn;
  TE(i) = err;
  MS(i) = sum(max(abs(w))>1e-4);
  
  w1 = abs(w(:,1:2))<1e-4;
  w2 = abs(w(:,3:end))<1e-4;
  IZ(i) = sum(sum(w1))-(abs(w(2,2))<1e-4); 
  CZ(i) = sum(sum(w2))+(abs(w(2,2))<1e-4); 
  
if(MS(i)==2 & max(abs(w(:,1)))>1e-4 & max(abs(w(:,2)))>1e-4)  
  CM = CM+1;
end

  i
  lambda
  err
  xind
end

mean(TE)%0.12
std(TE)%0.0143

mean(CZ)%563.4800
std(CZ)%47.3477

mean(IZ)%0
std(IZ)%0

mean(MS)%16.71
std(MS)%21.3945

CM%22






