

clear all;clc;
addpath('C:/Users/nli/Documents/personal/supSCAD simulation/glmnet_matlab');



n=200;  %train and tune data size
d=200;  %input vector dimension
K=3;    %3-class
nn=40000; %test data size
N=n+nn; 
r=100; %replicates


ytrain2 = mnrnd(1,[1/3 1/3 1/3],n);
ytrain = ytrain2*(1:K)';

ytest2 = mnrnd(1,[1/3 1/3 1/3],nn);
ytest = ytest2*(1:K)';

kk1=sum(ytrain2,1);

kk2 = sum(ytest2,1);
kk = kk1+kk2;

sigma = [0.189 0;
         0 0.189];



TE = zeros(r,1); %test error
P1 = zeros(r,1);
P2 = zeros(r,1);
CZ = zeros(r,1);
IZ = zeros(r,1);
MS = zeros(r,1);
CM = 0;
L = zeros(r,1);
EGKL = zeros(r,1);
Mu = [cos(pi/3) sin(pi/3);
       cos(pi) sin(pi);
       cos(5*pi/3) sin(5*pi/3)];


%tuning lambda
 lam = 2.^linspace(10,-6,17);

stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();


for i = 1:r
    
defaultStream.Substream = i;
 
 %simulation setup
xtrain = NaN(n,2);
xtest = NaN(nn,2);


 mu = [cos(pi/3) sin(pi/3)];
 X1 = mvnrnd(mu,sigma,kk(1));
 
 xtrain((ytrain==1),:) = X1(1:kk1(1),:);
 xtest((ytest==1),:) = X1((kk1(1)+1):end,:);

 
 mu = [cos(pi) sin(pi)];
 X2 = mvnrnd(mu,sigma,kk(2)); 
 
 xtrain((ytrain==2),:) = X2(1:kk1(2),:);
 xtest((ytest==2),:) = X2((kk1(2)+1):end,:);
  
 mu = [cos(4*pi/3) sin(4*pi/3)];
 X3 = mvnrnd(mu,sigma,kk(3)); 
 
xtrain((ytrain==3),:) = X3(1:kk1(3),:);
xtest((ytest==3),:) = X3((kk1(3)+1):end,:);
 
 
  ptrue2 = zeros(nn,K);
 for t = 1:nn
    for k = 1:K
    ptrue2(t,k) = mvnpdf(xtest(t,:),Mu(k,:),sigma);
    end
end
s2 = sum(ptrue2,2);
ptrue2 = ptrue2./repmat(s2,1,K);
 
 
xx = sqrt(0.5)*randn(N,d-2);
xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];

 meanx=mean(xtrain);
 scalex=std(xtrain);
 xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
 xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);


options=glmnetSet();
options.standardize=false;
options.lambda=lam;
options.maxit=1000;

fit=glmnet(xtrain,ytrain,'multinomial',options);

ptrain_hat=log(glmnetPredict(fit,xtrain,[],'response'));
coef_hat=glmnetPredict(fit,[],[],'coefficients');


bic=zeros(length(lam),1);

for j = 1:length(lam)
coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),j);
coefs(:,2)=coef_hat{2}(2:(d+1),j);
coefs(:,3)=coef_hat{3}(2:(d+1),j);
coefs=coefs';
nz=sum(sum(abs(coefs)>1e-4));

bic(j)=-2*sum(sum(ytrain2.*ptrain_hat(:,:,j)))/n+log(n)*nz/n;
end
[me,select]=min(bic);
lam_select=lam(select);
L(i)=lam_select;
  

ytest_hat=glmnetPredict(fit,xtest,lam_select,'class');
err = sum(ytest_hat~=ytest)/nn;

prob_test=glmnetPredict(fit,xtest,lam_select,'response');
P1(i)=sum(sum(abs(ptrue2-prob_test)))/nn;
P2(i)=sum(sum((ptrue2-prob_test).^2))/nn;
EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(prob_test))))/nn;
  
TE(i) = err;

coefs=zeros(d,K);
coefs(:,1)=coef_hat{1}(2:(d+1),select);
coefs(:,2)=coef_hat{2}(2:(d+1),select);
coefs(:,3)=coef_hat{3}(2:(d+1),select);
coefs=coefs';

CZ(i) = sum(sum(abs(coefs(:,3:end))<1e-4))+(abs(coefs(2,2))<(1e-4));
IZ(i) = sum(sum(abs(coefs(:,1:2))<1e-4))-(abs(coefs(2,2))<(1e-4));

MS(i) = sum(max(abs(coefs))>1e-4);

if(MS(i)==2 & max(abs(coefs(:,1)))>1e-4 & max(abs(coefs(:,2)))>1e-4)  
  CM = CM+1;
end



i
MS(i)
err

end

mean(TE)%0.11

mean(P1)

mean(P2)

mean(CZ)

mean(IZ)

mean(MS)% 2.8

CM %44

mean(EGKL)



