

clear all;clc;
addpath('C:/tomlab');
addpath('C:/Users/Jean Wu/Dropbox/submission/supSCAD simulation/LR_examples/supSCAD_MCP');
startup;


n=200;  %train and tune data size
d=200;  %input vector dimension
K=3;    %3-class
nn=40000; %test data size
N=n+nn; 
r=100; %replicates



sigma = [0.3 0;
         0 0.3];

TE = zeros(r,1); %test error
P1 = zeros(r,1);
P2 = zeros(r,1);
CZ = zeros(r,1);
IZ = zeros(r,1);
MS = zeros(r,1);
CM = 0;
L = zeros(r,1);
EGKL = zeros(r,1);
Mu = [cos(pi/3) sin(pi/3);
       cos(pi) sin(pi);
       cos(5*pi/3) sin(5*pi/3)];


%tuning lambda
 lam = 2.^linspace(3,-6,10);

stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();

B = zeros(d+1,K);

for i = 1:r
    
defaultStream.Substream = i;
 
 %simulation setup
 
 ytrain2 = mnrnd(1,[1/3 1/3 1/3],n);
ytrain = ytrain2*(1:K)';

ytest2 = mnrnd(1,[1/3 1/3 1/3],nn);
ytest = ytest2*(1:K)';

kk1=sum(ytrain2,1);

kk2 = sum(ytest2,1);
kk = kk1+kk2;


xtrain = NaN(n,2);
xtest = NaN(nn,2);


 mu = [cos(pi/3) sin(pi/3)];
 X1 = mvnrnd(mu,sigma,kk(1));
 
 xtrain((ytrain==1),:) = X1(1:kk1(1),:);
 xtest((ytest==1),:) = X1((kk1(1)+1):end,:);

 
 mu = [cos(pi) sin(pi)];
 X2 = mvnrnd(mu,sigma,kk(2)); 
 
 xtrain((ytrain==2),:) = X2(1:kk1(2),:);
 xtest((ytest==2),:) = X2((kk1(2)+1):end,:);
  
 mu = [cos(5*pi/3) sin(5*pi/3)];
 X3 = mvnrnd(mu,sigma,kk(3)); 
 
xtrain((ytrain==3),:) = X3(1:kk1(3),:);
xtest((ytest==3),:) = X3((kk1(3)+1):end,:);
 
 
  ptrue2 = zeros(nn,K);
 for t = 1:nn
    for k = 1:K
    ptrue2(t,k) = mvnpdf(xtest(t,:),Mu(k,:),sigma);
    end
end
s2 = sum(ptrue2,2);
ptrue2 = ptrue2./repmat(s2,1,K);
 
 
xx = sqrt(0.5)*randn(N,d-2);
xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];

 meanx=mean(xtrain);
 scalex=std(xtrain);
 xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
 xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);


 
 
 
bic=zeros(length(lam),3);

for j = 1:length(lam)
     [w,b,xind] = LRcompositeMCPLLAr(xtrain,ytrain,lam(j),B);
     ftrain = xtrain*w+ones(n,1)*b';
     ftrain = exp(ftrain);
     ftrain2 = sum(ftrain,2);
     ptrain = log(ftrain./repmat(ftrain2,1,K));
     nz = sum(sum(abs(w)>1e-4));
    
     bic(j,1) =  lam(j);
     bic(j,2) = -2*sum(sum(ytrain2.*ptrain))/n+log(n)*nz/n;
     bic(j,3) = length(xind);
end
[mn,index] = min(bic(:,2));
  lambda = bic(index,1);
  L(i) = lambda;
  

[w,b,xind,ind] = LRcompositeMCPLLAr(xtrain,ytrain,lambda,B);
     ftest = xtest*w+ones(nn,1)*b';
     ftest = exp(ftest);
     ftest2 = sum(ftest,2);
     ftest = ftest./repmat(ftest2,1,K);
     [fftest,index] = max(ftest,[],2);
     err = sum(ytest~=index)/nn;


  P1(i) = sum(sum(abs(ftest-ptrue2)))/nn;
  P2(i) = sum(sum((ftest-ptrue2).^2))/nn;
  TE(i) = err;
 
  EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(ftest))))/nn;

  
  w2=w';
MS(i) = sum(max(abs(w2))>1e-4);


if(MS(i)==2 & max(abs(w2(:,1)))>1e-4 & max(abs(w2(:,2)))>1e-4)  
  CM = CM+1;
end



 ww1 = abs(w2(:,1:2))<1e-4;
 ww2 = abs(w2(:,3:end))<1e-4;
 IZ(i) = sum(sum(ww1))-(abs(w2(2,2))<(1e-4)); 
 CZ(i) = sum(sum(ww2))+(abs(w2(2,2))<(1e-4));  



i
MS(i)
err
end


%%%% a=3 %%%%% a=3 %%%%   %%%% a=3 %%%%% a=3 %%%%
%%%% a=3 %%%%% a=3 %%%%   %%%% a=3 %%%%% a=3 %%%%
mean(TE)%0.1013
std(TE)% 0.0021
mean(P1)% 0.3649
std(P1)% 0.0172
mean(P2)% 0.0616
std(P2)% 0.0054
mean(CZ)% 594
std(CZ)%1.0918
mean(IZ)% 0
std(IZ)% 0
mean(MS)%2.26
std(MS)%0.5049
CM %77

mean(EGKL)%0.1490
std(EGKL)%0.0102


%%%% a=30 %%%%% a=30 %%%%   %%%% a=30 %%%%% a=30 %%%%
%%%% a=30 %%%%% a=30 %%%%   %%%% a=30 %%%%% a=30 %%%%

mean(TE)% 0.1133
std(TE)% 0.0045
mean(P1)% 0.4819
std(P1)% 0.0176
mean(P2)% 0.1049
std(P2)% 0.0074
mean(CZ)% 592.2400
std(CZ)% 1.6644
mean(IZ)% 0.1400
std(IZ)% 0.3487
mean(MS)%2.88
std(MS)%0.8322
CM %37

mean(EGKL)%0.2374
std(EGKL)%0.0119


