
clear all;clc;
addpath('C:\tomlab');
addpath('C:\Users\Jean Wu\Dropbox\submission\supSCAD simulation\SVM_examples');
startup;

n=200;  %train and tune data size
d=200;  %input vector dimension
K=3;    %3-class
nn=40000; %test data size
N=n+nn; 
r=100; %replicates

sigma = [0.3 0;
         0 0.3];

TE = zeros(r,1); %test error
P1 = zeros(r,1);
P2 = zeros(r,1);
CZ = zeros(r,1);
IZ = zeros(r,1);
MS = zeros(r,1);
CM = 0;
L = zeros(r,1);
EGKL = zeros(r,1);
Mu = [cos(pi/3) sin(pi/3);
       cos(pi) sin(pi);
       cos(5*pi/3) sin(5*pi/3)];


%tuning lambda
 Lambda = 2.^linspace(8,-7,16);

stream = RandStream('mrg32k3a');
RandStream.setGlobalStream(stream);
defaultStream = RandStream.getGlobalStream();



for i = 1:r
    
 defaultStream.Substream = i;
 
%simulation setup

ytrain2 = mnrnd(1,[1/3 1/3 1/3],n);
ytrain = ytrain2*(1:K)';

ytest2 = mnrnd(1,[1/3 1/3 1/3],nn);
ytest = ytest2*(1:K)';

kk1=sum(ytrain2,1);

kk2 = sum(ytest2,1);
kk = kk1+kk2;


xtrain = NaN(n,2);
xtest = NaN(nn,2);


 mu = [cos(pi/3) sin(pi/3)];
 X1 = mvnrnd(mu,sigma,kk(1));
 
 xtrain((ytrain==1),:) = X1(1:kk1(1),:);
 xtest((ytest==1),:) = X1((kk1(1)+1):end,:);

 
 mu = [cos(pi) sin(pi)];
 X2 = mvnrnd(mu,sigma,kk(2)); 
 
 xtrain((ytrain==2),:) = X2(1:kk1(2),:);
 xtest((ytest==2),:) = X2((kk1(2)+1):end,:);
  
 mu = [cos(5*pi/3) sin(5*pi/3)];
 X3 = mvnrnd(mu,sigma,kk(3)); 
 
xtrain((ytrain==3),:) = X3(1:kk1(3),:);
xtest((ytest==3),:) = X3((kk1(3)+1):end,:);
 
 
xx = sqrt(0.5)*randn(N,d-2);
xtrain = [xtrain xx(1:n,:)];
xtest = [xtest xx((n+1:end),:)];

 meanx=mean(xtrain);
 scalex=std(xtrain);
 xtrain=(xtrain-repmat(meanx,n,1))./repmat(scalex,n,1);
 xtest=(xtest-repmat(meanx,nn,1))./repmat(scalex,nn,1);


 %five-fold cross-validation
splitsize = floor(n/5) * ones(5, 1);
splitsize(5) = n - (5 - 1) * floor(n/5);
pn = randperm(n);

 Tunerr = zeros(length(Lambda),2);

for l = 1:length(Lambda)
      
       cv = zeros(1,5);
     for run = 1:5
      tuneindex = pn(((run - 1) * floor(n/5) + 1) : ((run - 1) * floor(n/5) + splitsize(run)));
      temp = zeros(n, 1);
      temp(tuneindex) = 1;
      cvytune = ytrain(logical(temp));
      cvytrain = ytrain(logical(1-temp));

      cvntrain = length(cvytrain);
      cvntune = length(cvytune);
      cvxtrain = xtrain(logical(1-temp),:);
      cvxtune = xtrain(logical(temp),:);
     [w,b] = MPSVMsupSCADLLA(cvxtrain,cvytrain,Lambda(l));
      ftune = cvxtune*w'+ones(cvntune,1)*b';
     [fftune,index] = max(ftune,[],2);
     cv(run) = sum(cvytune~=index)/cvntune;
     end
     Tunerr(l,1) =  Lambda(l);
     Tunerr(l,2) = mean(cv);
  end


  [mn,index] = min(Tunerr(:,2));
   lambda = Tunerr(index,1);
   L(i) = lambda;


 [w,b,xind,ind] = MPSVMsupSCADLLA(xtrain,ytrain,lambda);
  ftest = xtest*w'+ones(nn,1)*b';
  [fftest,index] = max(ftest,[],2);
%   ftest = 1./(1+ftest);
%   ffsum = sum(ftest,2);
%   ptest = ftest./repmat(ffsum,1,K);
%   ptest = 1-(K-1).*ptest; 
%   
%   
%  %scale P
% pmin = min(ptest,[],2);
% ptest = ptest - repmat(pmin,1,K);
% ptest = ptest./repmat(sum(ptest,2),1,K);
%   
%   P1(i) = sum(sum(abs(ptest-ptrue2)))/nn;
%   P2(i) = sum(sum((ptest-ptrue2).^2))/nn;
%   EGKL(i) = sum(sum(ptrue2.*(log(ptrue2)-log(ptest))))/nn;
    
   err = sum(ytest~=index)/nn;
   TE(i) = err;
%    MS(i) = sum(ind); 
     
CZ(i) = sum(sum(abs(w(:,3:end))<1e-4))+(abs(w(2,2))<(1e-4));
IZ(i) = sum(sum(abs(w(:,1:2))<1e-4))-(abs(w(2,2))<(1e-4));

MS(i) = sum(max(abs(w))>1e-4);


if(MS(i)==2 & max(abs(w(:,1)))>1e-4 & max(abs(w(:,2)))>1e-4)  
  CM = CM+1;
end

i
err
xind
end

mean(TE)% 0.1091
std(TE)% 0.0097
mean(CZ)% 569.51
std(CZ)% 43.9319
mean(IZ)% 0
std(IZ)% 0
mean(MS)% 13.7
std(MS)% 19.8242
CM % 32




